-- Praktikum digitaler Schaltungsentwurf 1, Aufgabe 2
-- Datei: Aug2/ISE/Schaltungsrahmen.vhdl
--
-- Schaltungsrahmen zum Test eines linear rückgekoppelten
-- Schieberegisters mit einem Logikanalysator
--
-- 11.01.2011, G. Kemnitz
------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
library UNISIM;
use UNISIM.VComponents.all;


entity Gesamtschaltung is
 port(GCLK0, SW0, BTN0: in std_logic;
      LD, LA: out std_logic_vector(7 downto 0));
end entity;

architecture a of Gesamtschaltung is
 signal y: std_logic_vector(7 downto 0);
 signal T, TBufG: std_logic:='0';
begin

 Taktteiler: process(GCLK0)
  variable Ct: natural range 0 to 25000000;
 begin
  if rising_edge(GCLK0) then
   Ct := Ct +1;
   if SW0='1' or Ct = 25000000 then
    T <= not T;
    Ct := 0;
	end if;
  end if;
 end process;
 
 Taktnetztreiber: BUFG
   port map (
      O => TBufG,     -- Clock buffer output
      I => T          -- Clock buffer input
   );

 TestObj: entity work.LFSR port map(T=>TBufG, I=>BTN0, y=>y(3 downto 0));
 y(7 downto 4) <= T&"000";
 LD <= y;
 LA <= y;
end architecture;
